#if !defined(__ANIM_H__)
#define __ANIM_H__
#include <sys/time.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>

typedef struct __animStruct 
{
  int view;
  int anim;
  int size;
  int max;
  int width,height;
  /* for Statistics */
  int swapCount;
  int hilightCount;
  struct timeval before;
  u_int wait;
  int *data;
  GC gc;
  GC tmpgc;
  Display *display;
  Window window;
  Pixmap pixmap;
  unsigned long normalColor,hilightColor,backgroundColor;
} animStruct;

animStruct AnimStruct;

void AnimInit(int dataSize,int view);
void AnimInitData(int pos,int value);
void AnimShowData(int i);
void AnimSwapData(int i,int j);
void AnimHilightData(int pos);
void AnimUnhilightData(int pos);
void AnimSetWaitTime(int time);
void AnimShowStats();
void AnimSetView(int value);
void AnimSetAnimation(int value);

#define ANIM            1
#define NoANIM          0
#define VIEW            1
#define NoVIEW          0
#define ANIM_WIDTH      (600)
#define ANIM_HEIGHT     (480)
#define ANIM_WAIT_TIME  (50000)
#define ANIM_STEP       (20)
#define ANIM_HOP        (50)
#define AnimMax(x,y)    ((x)>=(y)?(x):(y))
#define AnimMin(x,y)    ((x)<=(y)?(x):(y))
#endif
