#include "anim.h"
#define DATA_SIZE       100

int data[DATA_SIZE];

int partition(int start,int end,int pivotindex)
{
  int i;
  int left=start;
  int right=end;
  int pivot;
  int point;

  if(left<right)
  {
    point=start;
    pivot=data[pivotindex];
    if(pivotindex!=start)
    {
      swap(pivotindex,start);
      AnimSwapData(pivotindex,start);
    }

    for(i=start+1;i<=end;i++)
    {
      if(data[i]<=pivot)
      {
        point++;
        if(point!=i)
        {
          swap(point,i);
          AnimSwapData(point,i);
        }
      }
    }
    if(point!=start)
    {
      swap(start,point);
      AnimSwapData(start,point);
    }
    data[point]=pivot;
  }
  return(point);
}

int findpivot(int start,int end)
{
  int w1,w2,w3;
  int mid=(int)((start+end)/2.0);
  
  if(start>end)
    return(-1);

  w1=data[start];
  w2=data[end];
  w3=data[mid];
  
  if(w1>w2)
  {
    if(w3>w1)
      return(start);
    else if(w3>w2)
      return(mid);
    else
      return(end);
  }
  else if(w2<w3)
    return(end);
  else if(w1>w3)
    return(start);
  else
    return(mid);
}

void quick_sort(int start,int end)
{
  int pivotindex;

  if(start>=end)
    return;

  pivotindex=findpivot(start,end);

  if(pivotindex!=-1)
  {
    int k=partition(start,end,pivotindex);
    quick_sort(start,k-1);
    quick_sort(k+1,end);
  }
}

int main()
{
  int i,j;

  initData(DATA_SIZE);
  quick_sort(0,DATA_SIZE-1);
  AnimShowStats();
}

  
