#include "anim.h"
#define DATA_SIZE       100

int data[DATA_SIZE];

int partition(int *start,int *end,int pivotindex)
{
  int i,j,pivot;
  
  i=*start;
  j=*end;
  pivot=data[pivotindex];

  while(i<=j)
  {
    while(data[i]<pivot)
    {
      i++;
      AnimHilightData(i);
      AnimUnhilightData(i);
    }
    while(data[j]>pivot)
    {
      j--;
      AnimHilightData(j);
      AnimUnhilightData(j);
    }
    if(i<=j)
    {
      swap(i,j);
      AnimSwapData(i,j);
      i++;
      j--;
    }
  }
  *start=i;
  *end=j;
}


int findpivot(int start,int end)
{
  int w1,w2,w3;
  int mid=(int)((start+end)/2.0);
  
  if(start>end)
    return(-1);

  w1=data[start];
  w2=data[end];
  w3=data[mid];
  
  if(w1>w2)
  {
    if(w3>w1)
      return(start);
    else if(w3>w2)
      return(mid);
    else
      return(end);
  }
  else if(w2<w3)
    return(end);
  else if(w1>w3)
    return(start);
  else
    return(mid);
}

void real_qsort(int start,int end)
{
  int pivotindex=findpivot(start,end);
  int nstart=start;
  int nend=end;

  if(end-start<=10)
    return;

  if(pivotindex!=-1) {
      partition(&nstart,&nend,pivotindex);
      real_qsort(start,nend);
      real_qsort(nstart,end);
    }
}

void insert_sort()
{
  int i,j;
  
  for(i=1;i<DATA_SIZE;i++)
  {
    j=i;
    while(data[j]<data[j-1] && j>0)
    {
      swap(j,j-1);
      AnimSwapData(j,j-1);
      j--;
    }
  }
}

void quick_sort(int start,int end)
{
  int pivotindex;

  real_qsort(start,end);
  insert_sort();
}

int main()
{
  int i,j;

  initData(DATA_SIZE);
  quick_sort(0,DATA_SIZE-1);
  AnimShowStats();
}

  
